<?php
/**
 * @package    Joomla.Component.Builder
 *
 * @created    30th April, 2015
 * @author     Llewellyn van der Merwe <http://www.joomlacomponentbuilder.com>
 * @github     Joomla Component Builder <https://github.com/vdm-io/Joomla-Component-Builder>
 * @copyright  Copyright (C) 2015 - 2018 Vast Development Method. All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import the list field type
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');

/**
 * Existingvalidationrules Form Field class for the Componentbuilder component
 */
class JFormFieldExistingvalidationrules extends JFormFieldList
{
	/**
	 * The existingvalidationrules field type.
	 *
	 * @var		string
	 */
	public $type = 'existingvalidationrules';

	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return	array		An array of JHtml options.
	 */
	public function getOptions()
	{
		// get the existing validation rules names
		if ($items = ComponentbuilderHelper::getExistingValidationRuleNames())
		{
			// load the items
			$options = array(JHtml::_('select.option', '', 'Select an option'));
			foreach($items as $item)
			{
				$options[] = JHtml::_('select.option', $item, ComponentbuilderHelper::safeString($item, 'Ww'));
			}
			return $options;
		}
		return array(JHtml::_('select.option', '', JText::_('COM_COMPONENTBUILDER_NO_VALIDATION_RULES_FOUND')));
	}
}
